VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Unsubscriber"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IDisposable

Private m_Observable As IObservable
Private m_Observer As IObserver

Friend Sub Init(ByVal Observable As IObservable, ByVal Observer As IObserver)
    Set m_Observable = Observable
    Set m_Observer = Observer
End Sub

Private Sub IDisposable_Dispose()
    If m_Observable Is Nothing Then Exit Sub
    
    Call m_Observable.Unsubscribe(m_Observer)
End Sub
