VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ReadOnlyCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IReadOnlyCollection
Implements ICollection
Implements IEnumerable
Implements IList

Private m_List As IList

'Public Function Key(ByVal Index As Long) As String
'    Key = m_List.Keys.Item(Index).Name
'End Function

Public Sub Init(ByVal List As IList)
    If m_List Is Nothing = False Then Call Err.Raise(vbObjectError, , "Collection already filled")

    Set m_List = List
End Sub

'Subs
Public Sub CopyTo(arrayTo As Variant, ByVal index As Long)
    Call m_List.CopyTo(arrayTo, index)
End Sub

'Functions
Public Function Contains(Value As Variant) As Boolean
    Contains = m_List.Contains(Value)
End Function

'Public Function Equals(ByVal Obj As Object) As Boolean
'End Function

'Public Function Equals(ByVal ObjA As Object, ByVal ObjB As Object) As Boolean
'End Function

Public Function GetEnumerator() As IEnumerator
Attribute GetEnumerator.VB_UserMemId = -4
    Set GetEnumerator = m_List.GetEnumerator
End Function

Public Function IndexOf(Value As Variant) As Long
    IndexOf = m_List.IndexOf(Value)
End Function

'Public Function ReferenceEquals(ByVal ObjA As Object, ByVal ObjB As Object) As Boolean
'End Function

'Public Function ToString() As String
'End Function

'Properties
Public Property Get Count() As Long
    Count = m_List.Count
End Property

Public Property Get Item(ByVal index As Long) As Variant
Attribute Item.VB_UserMemId = 0
    Call SwapVar(Item, m_List.Item(index))
End Property

Private Property Set ICollection_Item(ByVal index As Long, ByVal RHS As Object)
    Set m_List.Item(index) = RHS
End Property

Private Property Let ICollection_Item(ByVal index As Long, ByVal RHS As Variant)
    m_List.Item(index) = RHS
End Property

Private Property Get ICollection_Item(ByVal index As Long) As Variant
    Call SwapVar(ICollection_Item, m_List.Item(index))
End Property

Private Function IEnumerable_GetEnumerator() As IEnumerator
    Set IEnumerable_GetEnumerator = Me.GetEnumerator
End Function

Private Function IList_Add(Item As Variant) As Long
    Error 0
End Function

Private Sub IList_Clear()
    Error 0
End Sub

Private Function IList_Contains(Item As Variant) As Boolean
    IList_Contains = Me.Contains(Item)
End Function

Private Sub IList_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call Me.CopyTo(arrayTo, index)
End Sub

Private Property Get IList_Count() As Long
    IList_Count = Me.Count
End Property

Private Function IList_GetEnumerator() As IEnumerator
    Set IList_GetEnumerator = Me.GetEnumerator
End Function

Private Function IList_IndexOf(Item As Variant) As Long
    IList_IndexOf = Me.IndexOf(Item)
End Function

Private Sub IList_Insert(ByVal index As Long, Item As Variant)
    Error 0
End Sub

Private Property Get IList_IsFixedSize() As Boolean
    IList_IsFixedSize = True
End Property

Private Property Get IList_IsReadOnly() As Boolean
    IList_IsReadOnly = True
End Property

Private Property Set IList_Item(ByVal index As Long, RHS As Object)
    Error 0
End Property

Private Property Let IList_Item(ByVal index As Long, RHS As Variant)
    Error 0
End Property

Private Property Get IList_Item(ByVal index As Long) As Variant
    Call SwapVar(IList_Item, Me.Item(index))
End Property

Private Sub IList_Remove(Item As Variant)
    Error 0
End Sub

Private Sub IList_RemoveAt(ByVal index As Long)
    Error 0
End Sub

Private Sub ICollection_Add(Item As Variant)
    Error 0
End Sub

Private Sub ICollection_Clear()
    Error 0
End Sub

Private Property Get ICollection_IsReadOnly() As Boolean
    ICollection_IsReadOnly = True
End Property

Private Function ICollection_Remove(Value As Variant) As Boolean
    Error 0
End Function

Private Function ICollection_Contains(Item As Variant) As Boolean
    ICollection_Contains = Me.Contains(Item)
End Function

Private Sub ICollection_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call Me.CopyTo(arrayTo, index)
End Sub

Private Property Get ICollection_Count() As Long
    ICollection_Count = Me.Count
End Property

Private Function ICollection_GetEnumerator() As IEnumerator
    Set ICollection_GetEnumerator = Me.GetEnumerator
End Function

'Private Sub IReadOnlyCollection_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
'    Call Me.CopyTo(arrayTo, index)
'End Sub

Private Property Get IReadOnlyCollection_Count() As Long
    IReadOnlyCollection_Count = Me.Count
End Property

Private Function IReadOnlyCollection_GetEnumerator() As IEnumerator
    Set IReadOnlyCollection_GetEnumerator = Me.GetEnumerator
End Function
