VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Controls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetParent Lib "user32.dll" (ByVal hwnd As Long) As Long

Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As Point) As Long
Private Declare Function WindowFromPoint Lib "user32.dll" (ByVal xPoint As Long, ByVal yPoint As Long) As Long

Private Declare Function GetClassName Lib "user32.dll" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long

Private Const C_MDIFORMCLASS_IDE = "ThunderMDIForm"
Private Const C_MDIFORMCLASS_EXE = "ThunderRT6MDIForm"

Private Const C_FORMCLASS_IDE_DC = "ThunderFormDC"
Private Const C_FORMCLASS_EXE_DC = "ThunderRT6FormDC"
Private Const C_FORMCLASS_IDE = "ThunderForm"
Private Const C_FORMCLASS_EXE = "ThunderRT6Form"

Private Type Point
    X As Long
    Y As Long
End Type

Private Declare Function SetWindowLong Lib "user32" Alias _
        "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
        As Long, ByVal dwNewLong As Long) As Long

Private Declare Function GetWindowLong Lib "user32" Alias _
        "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
        As Long) As Long

Private Declare Function GetWindowRect Lib "user32" (ByVal _
        hwnd As Long, lpRect As Rect) As Long

Private Declare Function SetWindowPos Lib "user32" (ByVal _
        hwnd As Long, ByVal hWndInsertAfter As Long, ByVal _
        X As Long, ByVal Y As Long, ByVal cx As Long, _
        ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long

Private Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type size
    cx As Long
    cy As Long
End Type

Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hDC As Long) As Long

Private Declare Function SelectObject Lib "gdi32" _
   (ByVal hDC As Long, ByVal hObject As Long) As Long

Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" ( _
     ByVal hDC As Long, _
     ByVal lpStr As String, _
     ByVal nCount As Long, _
     ByRef lpRect As Rect, _
     ByVal wFormat As Long) As Long

Private Declare Function GetDC Lib "user32.dll" ( _
     ByVal hwnd As Long) As Long
     
Private Declare Function SetFocus Lib "user32.dll" ( _
     ByVal hwnd As Long) As Long
     
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As _
    Any, dest As Any, ByVal numBytes As Long)

Private Declare Function ShowScrollBar Lib "user32" _
    (ByVal hwnd As Long, ByVal wBar As Long, _
    ByVal bShow As Long) As Long
    
Private Declare Function GetTextExtentPoint32 Lib "gdi32" _
    Alias "GetTextExtentPoint32A" ( _
    ByVal hDC As Long, _
    ByVal lpsz As String, _
    ByVal cbString As Long, _
    ByRef lpSize As size _
    ) As Long

Private Type GCP_RESULTS
    lStructSize As Long
    lpOutString As String
    lpOrder As Long
    lpDX As Long
    lpCaretPos As Long
    lpClass As String
    lpGlyphs As String
    nGlyphs As Long
    nMaxFit As Long
End Type

Private Declare Function SetTextJustification Lib "gdi32.dll" ( _
     ByVal hDC As Long, _
     ByVal nBreakExtra As Long, _
     ByVal nBreakCount As Long) As Long
Private Declare Function SetTextCharacterExtra Lib "gdi32.dll" ( _
     ByVal hDC As Long, _
     ByVal nCharExtra As Long) As Long
Private Declare Function GetTabbedTextExtent Lib "user32.dll" Alias "GetTabbedTextExtentA" ( _
     ByVal hDC As Long, _
     ByVal lpString As String, _
     ByVal nCount As Long, _
     ByVal nTabPositions As Long, _
     ByRef lpnTabStopPositions As Long) As Long
     
Private Declare Function MapDialogRect Lib "user32.dll" ( _
     ByVal hDlg As Long, _
     ByRef lpRect As Rect) As Long
     
Public Function GetPropertyBagValue( _
        ByVal PropBag As PropertyBag, _
        ByVal PropertyName As String, _
        ByVal AlternativeName As String, _
        Optional ByVal DefaultValue As Variant) As Variant
 
    If IsMissing(DefaultValue) Then
        DefaultValue = Empty
    End If
    
    On Error GoTo ErrHandler
    
    GetPropertyBagValue = PropBag.ReadProperty(PropertyName, Null)
    
    If IsNull(GetPropertyBagValue) Then
        GetPropertyBagValue = PropBag.ReadProperty(AlternativeName, DefaultValue)
    End If
    
    Exit Function
ErrHandler:
    GetPropertyBagValue = DefaultValue
End Function

'Public Function AdjustListboxHScrollbarEx(ByVal hwnd As Long, ByVal hDC As Long) As Long
'    AdjustListboxHScrollbarEx = AdjustListboxHScrollbarInternal(hwnd, , hDC)
'End Function
'
'Public Sub AdjustListboxHScrollbar(ByVal hwnd As Long, Optional ByVal Width As Long)
'    Call AdjustListboxHScrollbarInternal(hwnd, Width)
'End Sub

'Private Function AdjustListboxHScrollbarInternal(ByVal hwnd As Long, Optional ByVal Width As Long, Optional ByVal hDC As Long) As Long
'    Dim i As Long
'    Dim SystemScrollBreite As Long
'    Dim hOldFont As Long
'    Dim m_hItemFont As Long
'    Dim CheckboxWidth As Long
'    Dim Count As Long
'    Dim Rect As Rect
'    Dim Number As Long
'
'    Const LB_SETHORIZONTALEXTENT As Long = &H194
'    Const LB_GETHORIZONTALEXTENT As Long = &H193
'    Const ITEM_MARGIN As Long = 4
'    Const SM_CXVSCROLL As Long = 2
'    Const CHECKBOX_WIDTH As Long = 14
'    Const WS_VSCROLL As Long = &H200000
'    Const LB_GETTEXTLEN As Long = &H18A
'    Const LB_GETCOUNT As Long = &H18B
'    Const LB_GETTEXT As Long = &H189
'    Const DT_SINGLELINE As Long = &H20
'    Const DT_CALCRECT As Long = &H400
'    Const WM_GETFONT As Long = &H31
'    Dim TempString As String * 255
'    Dim strText As String
'    Dim Units As Single
'
'    Const SM_CXMENUCHECK As Long = 71
'    Const LVM_FIRST As Long = &H1000
'    Const LVM_GETEXTENDEDLISTVIEWSTYLE As Long = (LVM_FIRST + 55)
'    Const LVS_EX_CHECKBOXES As Long = &H4
'
'    Const EM_SETTABSTOPS As Long = &HCB
'    Const LBS_USETABSTOPS As Long = &H80&
'
'    On Error GoTo ErrHandler
'
'    Units = GetDialogUnitsPerPixel(hwnd)
'
'    Count = SendMessage(hwnd, LB_GETCOUNT, 0&, ByVal 0&)
'
'    If Count > 0 Then
'        SystemScrollBreite = GetSystemMetrics(SM_CXVSCROLL)
'
'        If (SendMessage(hwnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, ByVal 0&) And LVS_EX_CHECKBOXES) > 0 Then
'            CheckboxWidth = GetSystemMetrics(SM_CXMENUCHECK)
'        End If
'
'        If Width = 0 Then
'            If hDC = 0 Then
'                hDC = GetDC(hwnd)
'
'                m_hItemFont = SendMessage(hwnd, WM_GETFONT, 0, ByVal 0)
'                hOldFont = SelectObject(hDC, m_hItemFont)
'            End If
'
'            Dim Tabstops() As Long
'            Dim UseTabs As Boolean
'
'            Number = SendMessage(hwnd, LB_GETTEXT, 0, ByVal TempString)
'
'            UseTabs = InStr(TempString, vbTab) > 0
'
'            If UseTabs Then
'                Tabstops = GetTabStops(hwnd, hDC, Units)
'            End If
'
'            For i = 0 To Count - 1
'                Number = SendMessage(hwnd, LB_GETTEXT, i, ByVal TempString)
'
'                strText = Left$(TempString, Number)
'
'                If UseTabs Then
'                    Dim length1 As Long
'
'                    length1 = LoWord(GetTabbedTextExtent(hDC, strText, -1, UBound(Tabstops) + 1, Tabstops(0)))
'
'                    If length1 > Width Then
'                        Width = length1
'                    End If
'                Else
'                    Dim size As size
'
'                    Call GetTextExtentPoint32(hDC, strText, Number, size)
'
'                    If size.cx > Width Then
'                        Width = size.cx
'                    End If
'                End If
'            Next i
'
''            Debug.Print Width; lastlength; Tabstops(UBound(Tabstops)); lasttext
'
'            If hOldFont <> 0 Then
'                Call SelectObject(hDC, hOldFont)
'                Call ReleaseDC(hwnd, hDC)
'            End If
'
'            Width = (Width + 0 + CheckboxWidth + ITEM_MARGIN) '/ Units
'        Else
'            Width = (Width + CheckboxWidth + ITEM_MARGIN) '/ Units
'        End If
'    End If
'
'    Call SendMessage(hwnd, LB_SETHORIZONTALEXTENT, Width, ByVal 0&)
'
'    AdjustListboxHScrollbarInternal = Width
'
'    Exit Function
'ErrHandler:
'    Debug.Print Err.Description
'    Debug.Assert 0
'
'    Call Err.Raise(Err.Number)
'    Resume
'End Function

Private Function GetTabStops(ByVal hwnd As Long, Optional ByVal hDC As Long, Optional ByVal Units As Single) As Long()
    Dim i As Long
    Dim j As Long
    Dim Contents() As String
    Dim Width As Long
    Dim Tabstops() As Long
    Dim Count As Long
    Dim TempString As String * 255
    Dim Length As Long
    Dim size As size
    
    Const LB_GETCOUNT As Long = &H18B
    Const LB_GETTEXT As Long = &H189
    
    On Error GoTo ErrHandler
       
    If Units = 0 Then
        Units = GetDialogUnitsPerPixel(hwnd)
    End If
    
    If hDC = 0 Then
        hDC = GetDC(hwnd)
    End If
    
    Length = SendMessage(hwnd, LB_GETTEXT, 0, ByVal TempString)
    
    Count = ApiStrCount(Left$(TempString, Length), vbTab)

    If Count = 0 Then
        Call mdlArray.InitArray(Tabstops, True)
    
        GoTo ReturnValue
    End If

    ReDim Tabstops(Count - 1)
        
    Count = SendMessage(hwnd, LB_GETCOUNT, 0&, ByVal 0&)

    For i = 0 To Count - 1
        Length = SendMessage(hwnd, LB_GETTEXT, i, ByVal TempString)
        
        Contents = Split(Left$(TempString, Length), vbTab)

        If UBound(Contents) > -1 Then
            For j = 0 To UBound(Contents) - 1
'                Debug.Assert InStr(Contents(j), "#77") = 0
                
'                Width = LoWord(GetTabbedTextExtent(hDc, Contents(j), -1, 0, 0)) / Units
                
                Call GetTextExtentPoint32(hDC, Contents(j), Len(Contents(j)), size)
                
'                Debug.Assert Width = CInt(Size.cx / Units)

                Width = (size.cx + 5) / Units
                
                If j <= UBound(Tabstops) Then
                    If Width > Tabstops(j) Then
                        Tabstops(j) = Width
                    End If
                Else
                    Exit For
                End If
            Next j
        End If
    Next i
    
    For i = 1 To UBound(Tabstops)
        Tabstops(i) = Tabstops(i) + Tabstops(i - 1)
        
'        Debug.Print Tabstops(i)
    Next
    
ReturnValue:
    
    GetTabStops = Tabstops
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Call mdlArray.InitArray(Tabstops, True)
    
    GoTo ReturnValue
    
'    Call Err.Raise(Err.Number)
    Resume
End Function

Public Function GetDialogUnitsPerPixel(ByVal hwnd As Long) As Single
    GetDialogUnitsPerPixel = mdlInformation.GetDialogUnitsPerPixel(hwnd)
End Function

Private Function LoWord(ByVal lDWord As Long) As Integer
    If lDWord And &H8000& Then
        LoWord = lDWord Or &HFFFF0000
    Else
        LoWord = lDWord And &HFFFF&
    End If
End Function

'Private Function DrawJustifiedText(hdc As Long, lpString As String, nCount As Long, lpRect As Rect, Align As Long) As Long
'    Dim x As Integer, y As Integer
'    Dim w As Integer, h As Integer
'    Dim i As Integer, j As Integer
'    Dim Size As Size
'    Dim cLineStart As Char, cStart As Char, cEnd As Char
'    Dim TextMetrics As TEXTMETRIC
'
'    Call GetTextMetrics(hdc, VarPtr(TextMetrics))
'
'    h = TextMetrics.tmHeight
'    y = lpRect.Top
'
'    cStart = CChar(lpString)
'    cLineStart = cStart
'    j = -1
'
'    Select Case Align
'        Case -1, TA_LEFT
'            x = lpRect.Left
'        Case TA_RIGHT
'            x = lpRect.Right
'        Case TA_CENTER
'            x = (lpRect.Right + lpRect.Left) / 2
'    End Select
'
'    Call SetTextAlign(hdc, IIf(Align = -1, TA_LEFT, Align))
'
'    For i = 0 To nCount
'        If lpString(i) = " " Or lpString(i) = ControlChars.Tab Or _
'                lpString(i) = vbNullChar Or i = nCount Or _
'                a_strnicmp(lpString + i, vbCr & vbLf, 2) = 0 Then
'
'            cEnd = CChar(lpString) + i
'            Size.cx = CInt(LoWord(GetTabbedTextExtent(hdc, cLineStart, cEnd - cLineStart, 0, 0)))
'            w = Size.cx
'
'            If w > lpRect.Right - lpRect.Left Then
'                Size.cx = CInt(LoWord(GetTabbedTextExtent(hdc, cLineStart, cStart - cLineStart, 0, 0)))
'
'                w = (lpRect.Right - lpRect.Left) - Size.cx
'
'                If Align = -1 Then
'                    Call SetTextJustification(hdc, w, j)
'                End If
'
'                Call TabbedTextOut(hdc, x, y, cLineStart, cStart - cLineStart, 0, 0, lpRect.Left)
'
'                If Align = -1 Then
'                    Call SetTextJustification(hdc, 0, 0)
'                End If
'
'                y = y + h
'
'                If cStart.Target = " " Then
'                    cStart = cStart + 1
'                End If
'
'                cLineStart = cStart
'                j = 0
'            Else
'                If lpString(i) = " " Then
'                    j = j + 1
'                End If
'
'                cStart = cEnd
'            End If
'        End If
'
'        If lpString(i) = ControlChars.NullChar Or i = nCount Then
''            Call TabbedTextOut(hdc, x, y, cLineStart, i - (cLineStart - lpString), 0, 0, lpRect.Left)
'        End If
'
'        If a_strnicmp(lpString + i, vbCr & vbLf, 2) = 0 Then
''            Call TabbedTextOut(hdc, x, y, cLineStart, i - (cLineStart - lpString), 0, 0, lpRect.Left)
'
'            cLineStart = CChar(lpString) + i + 2
'            cStart = cLineStart
'
'            y = y + h
'            w = 0
'            j = 0
'        End If
'    Next
'
'    DrawJustifiedText = y - lpRect.Top
'End Function

Public Sub SetCtlFocus(ByVal hwnd As Long)
    Call SetFocus(hwnd)
End Sub

Public Function GetFormControl(ByVal Form As Object, ByVal ControlName As String) As Object 'v2
    On Error Resume Next
    Set GetFormControl = Form.Controls.Item(ControlName)
End Function

Public Function IsControlOnForm(ByVal Form As Object, ByVal ControlName As String) As Boolean 'v2
    On Error Resume Next
    IsControlOnForm = Len(TypeName(Form.Controls.Item(ControlName))) > 0
End Function
     
Public Function GetControlObject(ByVal UserControl As Object) As Variant
    Dim VBCE As VBControlExtender
    
    On Error GoTo ErrHandler

    If TypeOf UserControl Is VBControlExtender Then
        Set VBCE = UserControl
        Set GetControlObject = VBCE.Object
    End If
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Call Err.Raise(Err.Number)
    Resume
End Function
     
Public Sub SetComboMaxLength(ByVal hwnd As Long, Optional ByVal MaxLength As Long = 50)
    Call ApiSetComboMaxLength(hwnd, MaxLength)
End Sub

Public Sub SetDropDownListWidth(ByVal hwnd As Long, Optional ByVal hDC As Long)
    Call ApiSetDropDownListWidth(hwnd, hDC)
End Sub

Public Sub SetDropDownListHeight(ByVal hwnd As Long, Optional ByVal ListHeight As Long)
    Call ApiSetDropDownListHeight(hwnd, ListHeight)
End Sub

Public Function GetWindowStyles(ByVal hwnd As Long, Optional ByVal EX_STYLE As Boolean) As Long
    Dim lngStyleMode As Long
    
    On Error GoTo ErrHandler
  
    Const GWL_STYLE As Long = (-16)
    Const GWL_EXSTYLE As Long = -20
    
    If EX_STYLE Then
        lngStyleMode = GWL_EXSTYLE
    Else
        lngStyleMode = GWL_STYLE
    End If
    
    GetWindowStyles = GetWindowLong(hwnd, lngStyleMode)
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Exit Function
    Resume
End Function

Public Sub SetWindowStyles(ByVal hwnd As Long, Optional ByVal ToggleStyle As Long, Optional ByVal Value As Boolean, Optional ByVal EX_STYLE As Boolean, Optional ByVal Refresh As Boolean = True)
    Dim lngStyle As Long
    Dim R As Rect
    Dim lngStyleMode As Long
    
    On Error GoTo ErrHandler
  
    Const SWP_FRAMECHANGED As Long = &H20
    Const GWL_STYLE As Long = (-16)
    Const GWL_EXSTYLE As Long = -20
    
    If EX_STYLE Then
        lngStyleMode = GWL_EXSTYLE
    Else
        lngStyleMode = GWL_STYLE
    End If
    
    lngStyle = GetWindowLong(hwnd, lngStyleMode)
    
    If Value Then
        lngStyle = lngStyle Or ToggleStyle
    Else
        lngStyle = lngStyle And (Not ToggleStyle)
    End If
    
    Call SetWindowLong(hwnd, lngStyleMode, lngStyle)
    
    If Refresh Then
        Call GetWindowRect(hwnd, R)
        Call SetWindowPos(hwnd, 0, R.Left, R.Top, _
                R.Right - R.Left, R.Bottom - R.Top, SWP_FRAMECHANGED)
    End If
    
    Exit Sub
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Exit Sub
    Resume
End Sub

Public Function FindFormhWnd(Optional ByVal hwnd As Long, Optional ByRef LastFoundClass As String) As Long
    Dim pt As Point
    Dim k As Long
    
    If hwnd = 0 Then
        Call GetCursorPos(pt)
        
        hwnd = WindowFromPoint(pt.X, pt.Y)
    End If
    
    LastFoundClass = Space$(128)
    
    k = GetClassName(hwnd, ByVal LastFoundClass, 128)
    LastFoundClass = Left$(LastFoundClass, k)

    Select Case LastFoundClass
        Case C_MDIFORMCLASS_IDE, C_MDIFORMCLASS_EXE, _
          C_FORMCLASS_IDE_DC, C_FORMCLASS_EXE_DC, C_FORMCLASS_IDE, _
          C_FORMCLASS_EXE
            FindFormhWnd = hwnd
        Case "ThunderRT6UserControlDC", "ThunderRT6UserControl", "ThunderRT6TextBox", "ThunderRT6ComboBox", "ThunderRT6CheckBox"
            FindFormhWnd = FindFormhWnd(GetParent(hwnd))
    End Select
End Function
