Attribute VB_Name = "mdlDate"
Option Explicit

Public Function LastDay(Optional ByVal Value As Date) As Date
    If Value = #12:00:00 AM# Then
        Value = Date
    End If
    
    LastDay = DateSerial(Year(Value), month(Value) + 1, 0)
End Function

Public Function CheckDateInterval(ByVal CheckDate As Date, ByVal StartDate As Date, ByVal Interval As Long, Optional ByVal EndDate As Date) As Boolean
    If EndDate = Empty Then
        EndDate = DateSerial(Year(Date), month(Date), 31)
    End If
    
    If DateDiff("m", CheckDate, EndDate) Then
        Exit Function
    End If
    
    If StartDate = Empty Then
        StartDate = DateSerial(Year(Date), month(Date), 1)
    End If
    
    If month(CheckDate) = month(StartDate) Then
        CheckDateInterval = True
        
        Exit Function
    End If
    
    If Interval = 1 Then 'jeden monat
        CheckDateInterval = True
    Else
        CheckDateInterval = ((DateDiff("m", StartDate, CheckDate) Mod Interval) = 0)
    End If
End Function

Public Function ApiEuroDate(Optional ByVal AnyDate As Date) As String
    If AnyDate = Empty Then
        AnyDate = Date
    End If

    ApiEuroDate = Year(AnyDate) & "-" & Format$(month(AnyDate), "00") & "-" & Format$(Day(AnyDate), "00")
    
    If Hour(AnyDate) > 0 Or Minute(AnyDate) > 0 Or Second(AnyDate) > 0 Then
        ApiEuroDate = ApiEuroDate & Format$(Hour(AnyDate), "00") & "-" & Format$(Minute(AnyDate), "00") & "-" & Format$(Second(AnyDate), "00")
    End If
End Function

Public Function ApiCTryDate(ByVal v As Variant) As Date
    On Error Resume Next

'    If IsDate(v) Then
        ApiCTryDate = CDate(v)
'    End If
End Function

'Public Function ApiGetTimeFromDate(ByVal dteDatum As Date) As String
'    ApiGetTimeFromDate = Format$(Hour(dteDatum), "00") & ":" & Format$(Minute(dteDatum), "00") & ":" & Format$(Second(dteDatum), "00")
'End Function
