Attribute VB_Name = "mdlMissing"
Option Explicit

Private Const DISP_E_PARAMNOTFOUND As Long = &H80020004

Public Missing As Variant

Public Sub CreateMissingVariant()
    Missing = CVErr(vbError)
        
    Call RtlMoveMemory(ByVal VarPtr(Missing) + 8, DISP_E_PARAMNOTFOUND, 4)
End Sub

Public Function SafeIsMissing(ByRef v As Variant) As Boolean
    Const DISP_E_PARAMNOTFOUND As Long = &H80020004
    
    Dim Value As Long
    
    If IsError(v) Then
        Call RtlMoveMemory(Value, ByVal VarPtr(v) + 8)
    
        SafeIsMissing = Value = DISP_E_PARAMNOTFOUND
    End If
End Function
