Attribute VB_Name = "Functions"
Option Explicit

Private Declare Function IIDFromString Lib "ole32" _
       (ByVal lpsz As String, ByRef lpiid As UUID) As Long
       
Private Declare Function CoCreateGuid Lib "ole32.dll" _
 (ByRef tGuid As UUID) As Long
 
Private Declare Function StringFromGUID2 Lib "ole32.dll" ( _
     ByRef rguid As UUID, _
     ByVal lpsz As String, _
     ByVal cchMax As Long) As Long
     
Public Function CreateGuid() As UUID
    Call CoCreateGuid(CreateGuid)
End Function

Public Function ClsIdFromGuid(UUID As UUID) As String
    Dim strGuid As String
    Dim lngRetVal As Long
    
    strGuid = String$(76, vbNullChar)
    lngRetVal = StringFromGUID2(UUID, strGuid, 80&)
    
    If lngRetVal > 0 Then
        ClsIdFromGuid = StrConv(strGuid, vbFromUnicode)
    End If
End Function

Public Function GuidFromClsId(ByVal ClsId As String) As UUID
    Dim lRet As Long
    lRet = IIDFromString(StrConv(ClsId, vbUnicode), GuidFromClsId)
End Function

